//------------------------------------------------------------------
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  DimGray
#property indicator_color2  Silver
#property indicator_color3  Gold
#property indicator_width1  2

extern int    RsiPeriod      = 50;
extern int    RsiPrice       = PRICE_CLOSE;
extern string PivotTimeFrame = "H4";

double tp[];
double tr[];
double rsi[];
int TimeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,rsi);
   SetIndexBuffer(1,tp);
   SetIndexBuffer(2,tr); SetIndexStyle(2,DRAW_SECTION);
      TimeFrame = stringToTimeFrame(PivotTimeFrame);
   IndicatorShortName("Rsi + "+timeFrameToString(TimeFrame)+" pivot + trend ("+RsiPeriod+")");
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,countedBars = IndicatorCounted();
      if (countedBars<0) return(-1);
      if (countedBars>0) countedBars--;
         int limit = MathMin(Bars-countedBars,Bars-1);
             for(; limit<Bars; limit++) if (iBarShift(NULL,TimeFrame,Time[limit])!=iBarShift(NULL,TimeFrame,Time[limit+1])) break;

   for(i=limit; i>=0; i--)
   {
      rsi[i] = iRSI(NULL,0,RsiPeriod,RsiPrice,i);
      if (TimeFrame>Period())
      {
         double phigh,plow,pclose;
            findPivot(phigh,plow,pclose,rsi[i],rsi[i],rsi[i],TimeFrame,i);
            tp[i] = (phigh+plow+pclose)/3.0;
               if (iBarShift(NULL,TimeFrame,Time[i])!=iBarShift(NULL,TimeFrame,Time[i+1]) || i==0) 
                     tr[i] = tp[i];
               else  tr[i]  = EMPTY_VALUE;
      }
   }
   return(0);
}



//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workPiv[][3];
#define _high  0
#define _low   1
#define _close 2

void findPivot(double &phigh, double &plow, double &pclose, double vhigh, double vlow, double vclose, int timeFrame, int i)
{
   if (ArrayRange(workPiv,0) != Bars) ArrayResize(workPiv,Bars); int r = Bars-i-1;
      workPiv[r][_high]  = vhigh;
      workPiv[r][_low ]  = vlow;
      workPiv[r][_close] = vclose;
      
   //
   //
   //
   //
   //
 
      i = iBarShift(NULL,timeFrame,Time[i]);
         datetime startTime = iTime(NULL,timeFrame,i+1);
         datetime endTime   = iTime(NULL,timeFrame,i);
      i = iBarShift(NULL,0,endTime)+1; r=Bars-i-1;

      //
      //
      //
      //
      //
      
      pclose = workPiv[r][_close];
      phigh  = workPiv[r][_high];
      plow   = workPiv[r][_low];

      for (i++,r--; Time[i]>=startTime && r>=0; i++,r--)      
      {
            phigh = MathMax(workPiv[r][_high],phigh);
            plow  = MathMin(workPiv[r][_low] ,plow );
      }
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}